uniform sampler2D SamplerRGB;
uniform mediump mat4 curvePoints;
uniform mediump mat3 inputMuls;

//uniform mediump float avgBright;
uniform mediump vec3 colorAdd;
uniform mediump vec3 colorMul;


varying highp vec2 texCoord;


mediump float spline( mediump int i, mediump float pos ) 
{
	return ((curvePoints[i][3]*pos + curvePoints[i][2])*pos +curvePoints[i][1])*pos + curvePoints[i][0];
}

void main()
{
	mediump vec3 sample = texture2D( SamplerRGB, texCoord ).rgb * inputMuls;
	//sample = clamp( sample + vec3(0.5-avgBright, 0.5-avgBright, 0.5-avgBright ), 0.0, 1.0);
	sample = clamp( (sample + colorAdd) * colorMul, 0.0, 1.0 );
	gl_FragColor = clamp( vec4( spline(0,sample.r), spline(1,sample.g), spline(2,sample.b), 1.0 ), 0.0, 1.0 );

}


