uniform sampler2D SamplerRGB;
uniform sampler2D lowDetailSamplerRGB;
uniform mediump float clarityMul;
uniform mediump vec3 colorAdd;
uniform mediump vec3 colorMul;
uniform mediump float desaturate;
uniform sampler2D lutTex;
varying highp vec2 texCoord;
    
#+LUT_BLITTER

void main()
{
	mediump vec3 rgb = texture2D( SamplerRGB, texCoord ).rgb;
	mediump vec3 ldrgb = texture2D( lowDetailSamplerRGB, texCoord ).rgb;
	rgb = clamp( rgb + (rgb-ldrgb)*clarityMul, 0.0, 1.0);
    
    rgb = lut3d( clamp((rgb + colorAdd)*colorMul, 0.0, 1.0)).rgb;
    mediump float grayval = dot( rgb, vec3(0.33,0.33,0.33));
    gl_FragColor = vec4( mix( rgb, vec3(grayval, grayval, grayval), desaturate ), 1.0);
	//gl_FragColor = vec4( lut3d( clamp((rgb + colorAdd)*colorMul, 0.0, 1.0)).rgb, 1.0);
}