	// bilateral 5x5
varying highp vec2 texCoord;
uniform mediump sampler2D text;
uniform highp vec2 backbufferSize;
uniform highp vec2 dir;


highp float gaussianMul( highp float dis ) {
    /*
    highp float sigma = 1.0;
    return (1.0 / sqrt(2.0*3.14159*sigma) ) * exp( -(dis*dis)/(2.0*sigma*sigma) );
     */
    // with sigma 1
    return 0.39894228040143 * exp( -(dis*dis)/2.0 );
}


mediump float colorMul( mediump vec3 c1, mediump vec3 c2 ) {
    c1 = c2-c1;
    return clamp( 1.0 - dot(c1,c1)*32.0, 0.0, 1.0 );
	//return clamp( 1.0 - sqrt(dot(c1,c1))*6.0, 0.0, 1.0 );
}


void main() {

  mediump vec3 middle = texture2D( text, texCoord ).rgb;

  highp float totalpower = 0.0;
  highp vec3 avg = vec3(0.0, 0.0, 0.0);
  //highp vec2 sampleR = vec2(dir.x/backbufferSize.x, dir.y/backbufferSize.y);
  //highp vec2 sampleR = vec2(dir.x*0.003,dir.y*0.003/backbufferSize.y*backbufferSize.x);
  highp vec2 sampleR = vec2(dir.x*0.00125, dir.y*0.00125*backbufferSize.x/backbufferSize.y);

  
  // Add the pixels which make up our window to the pixel array.
  for(int d = -7; d <= 7; d++) {
      highp vec2 offset = sampleR * (float(d));
	  highp vec3 sampled = texture2D(text, texCoord + offset).rgb;
      highp float tmul = colorMul( middle, sampled ) * gaussianMul( (float(d)) / 2.0 );
        //    return 1.0/(1.0+dot(ofs, ofs)*0.5);
	  avg += sampled * tmul;
	  totalpower += tmul;

  }

  gl_FragColor = vec4( avg/totalpower, 1.0 );
  
}



