	// bilateral 5x5
varying highp vec2 texCoord;
uniform mediump sampler2D text;
uniform highp vec2 backbufferSize;
uniform highp float rmul;


mediump float gaussianMul( mediump vec2 ofs ) {
	//return 1.0/(1.0+dot(ofs, ofs)*0.5);
    //return 1.0/(1.0+dot(ofs, ofs)*0.5);
    
     /*
     highp float sigma = 1.0;
     return (1.0 / sqrt(2.0*3.14159*sigma) ) * exp( -(dis*dis)/(2.0*sigma*sigma) );
     */
    // with sigma 1
    return exp( -(dot(ofs,ofs))/3.0 );
}

mediump float colorMul( highp vec3 c1, highp vec3 c2 ) {
	c1 = c2-c1;
    return exp(-dot(c1,c1)/0.01 );
}


void main() {

  mediump vec3 middle = texture2D( text, texCoord ).rgb;

  highp float totalpower = 0.0;
  highp vec3 avg = vec3(0.0, 0.0, 0.0);
  //highp vec2 sampleR = vec2(1.0/backbufferSize.x, 1.0/backbufferSize.y)*rmul;
  highp vec2 sampleR = vec2(0.0025, 0.0025*backbufferSize.x/backbufferSize.y)*rmul;
  
  // Add the pixels which make up our window to the pixel array.
  for(int dX = -3; dX <= 3; dX++) {
    for(int dY = -3; dY <= 3; dY++) {		
      highp vec2 offset = vec2(float(dX), float(dY));
	  highp vec3 sampled = texture2D(text, texCoord + offset * sampleR).rgb;
      //highp vec3 sampled = (texture2D(text, texCoord + offset * sampleR).rgb + texture2D(text, texCoord + offset * sampleR).rgb) * 0.5;
	  highp float tmul = colorMul( middle, sampled ) * gaussianMul( offset );
      //highp float tmul = colorMul( middle, sampled ) * exp(-dot(offset,offset)/0.1);
	  avg += sampled * tmul;
	  totalpower += tmul;
    }
  }

  gl_FragColor = vec4( avg/totalpower, 1.0 );
}



