uniform sampler2D texInput;
uniform sampler2D texBlend;
uniform mediump float blendPower;
uniform highp float blendLoop;

varying highp vec2 texCoord;
varying highp vec2 texCoord2;

//(Target > 0.5) * (1 - (1-2*(Target-0.5)) * (1-Blend)) + (Target <= 0.5) * ((2*Target) * Blend)
mediump vec4 blendOverlay( mediump vec4 base, mediump vec4 blend ) 
{
	return vec4(
		(base.r < 0.5 ? (2.0 * base.r * blend.r) : (1.0 - 2.0 * (1.0 - base.r) * (1.0 - blend.r))),
		(base.g < 0.5 ? (2.0 * base.g * blend.g) : (1.0 - 2.0 * (1.0 - base.g) * (1.0 - blend.g))),
		(base.b < 0.5 ? (2.0 * base.b * blend.b) : (1.0 - 2.0 * (1.0 - base.b) * (1.0 - blend.b))),1.0);
}

void main()
{
	mediump vec4 orig = texture2D(texInput, texCoord );
	mediump vec4 blen = texture2D(texBlend, texCoord2 *blendLoop);
	gl_FragColor = mix( orig, blendOverlay( orig, blen ), blendPower*blen.a );
}