uniform sampler2D texInput;
uniform sampler2D texBlend;
uniform mediump float blendPower;
uniform highp float blendLoop;

varying highp vec2 texCoord;
varying highp vec2 texCoord2;

mediump vec4 blendScreen( mediump vec4 base, mediump vec4 blend ) 
{
	return vec4(
		(1.0 - ((1.0-base.r) * (1.0-blend.r))),
		(1.0 - ((1.0-base.g) * (1.0-blend.g))),
		(1.0 - ((1.0-base.b) * (1.0-blend.b))), 1.0);
}

void main()
{
	mediump vec4 orig = texture2D(texInput, texCoord );
	mediump vec4 blen = texture2D(texBlend, texCoord2 * blendLoop);
	gl_FragColor = mix( orig, blendScreen( orig, blen ), blendPower*blen.a );
}