uniform sampler2D texInput;
uniform sampler2D texBlend;
uniform mediump float blendPower;
uniform highp float blendLoop;

varying highp vec2 texCoord;
varying highp vec2 texCoord2;

mediump vec4 blendSoftlight( mediump vec4 base, mediump vec4 blend ) 
{
	return vec4(
		(1.0 - 2.0*blend.r)*(base.r*base.r) + 2.0*blend.r*base.r,
		(1.0 - 2.0*blend.g)*(base.g*base.g) + 2.0*blend.g*base.g,
		(1.0 - 2.0*blend.b)*(base.b*base.b) + 2.0*blend.b*base.b,
		1.0);
}

void main()
{
	mediump vec4 orig = texture2D(texInput, texCoord );
	mediump vec4 blen = texture2D(texBlend, texCoord2 * blendLoop);

	gl_FragColor = mix( orig, blendSoftlight( orig, blen ), blendPower*blen.a );
	
}