uniform sampler2D SamplerRGB;
uniform sampler2D lowDetailSamplerRGB;

uniform mediump float bloom_mul;
uniform mediump float bloom_pow;
uniform mediump float bloom_sub;
uniform mediump float orig_submul;

varying highp vec2 texCoord;

  
void main()
{
	mediump vec3 ld = texture2D( lowDetailSamplerRGB, texCoord ).rgb;
	
	ld = clamp( (ld - vec3(bloom_sub, bloom_sub, bloom_sub)), 0.0, 1.0 );
	ld = vec3( pow(ld.r, bloom_pow), pow(ld.g, bloom_pow), pow(ld.b, bloom_pow) );
	

	ld = clamp( ld * bloom_mul, 0.0, 1.0 );
	mediump vec3 orig = texture2D( SamplerRGB, texCoord ).rgb;
	

    if (texCoord.y<0.5)
	gl_FragColor = vec4( ld.r + orig.r*(1.0-ld.r*orig_submul),
			   			 ld.g + orig.g*(1.0-ld.g*orig_submul),
					     ld.b + orig.b*(1.0-ld.b*orig_submul),
					     1.0 );
    else gl_FragColor = vec4(orig, 1.0);
    

}