uniform sampler2D blurMaps0;
uniform sampler2D blurMaps1;
uniform sampler2D blurMaps2;
uniform sampler2D blurMaps3;
uniform sampler2D blurMaps4;
varying highp vec2 texCoord;


mediump vec4 sampleBlurMap( highp vec2 uvcoord, mediump float pos )
{
   mediump int p=int(floor(pos));
   mediump float i=fract(pos);
   if (p == 0) {
       return texture2D(blurMaps0, uvcoord)*(1.0-i) + texture2D(blurMaps1, uvcoord)*(i);
   } else if (p == 1) {
       return texture2D(blurMaps1, uvcoord)*(1.0-i) + texture2D(blurMaps2, uvcoord)*(i);
   } else if (p == 2) {
       return texture2D(blurMaps2, uvcoord)*(1.0-i) + texture2D(blurMaps3, uvcoord)*(i);
   } else if (p == 3) {
       return texture2D(blurMaps3, uvcoord)*(1.0-i) + texture2D(blurMaps4, uvcoord)*(i);
   }
   return vec4(0.0, 0.0, 0.0, 0.0);
}

void main()
{
    mediump vec2 de = (texCoord-vec2(0.5, 0.5))*2.0;
    //mediump float amount=clamp( -0.6 + sqrt(dot(de,de)) * 5.0, 0.0, 3.9999);
    mediump float amount=clamp( -0.3 + de.x*de.x * 6.0, 0.0, 3.9999);
    gl_FragColor = sampleBlurMap( texCoord, amount );
}
