
uniform sampler2D blurMaps0;
uniform sampler2D blurMaps1;
uniform sampler2D blurMaps2;
uniform sampler2D blurMaps3;
uniform sampler2D blurMaps4;
uniform sampler2D blurAmount;						// map to define the amount of blurring
uniform sampler2D clarityMap;

uniform mediump float clarityMul;
varying highp vec2 texCoord;

#+libblurmap.glsl


void main()
{
    // new implementation: clarity is calculated after blurring
	mediump vec3 rgb = texture2D( blurMaps0, texCoord ).rgb;
	highp float amount = 1.0 - texture2D( blurAmount, texCoord ).g;
	//rgb = mix( rgb, sampleBlurMap( amount * 3.99 ), clamp( (amount - 0.2)*6.0, 0.0, 1.0 ));
	rgb = clamp( sampleBlurMap( amount * 3.99 ), 0.0, 1.0);
    
	mediump vec3 ldrgb = texture2D( clarityMap, texCoord ).rgb;
	rgb = clamp( rgb + (rgb-ldrgb)*clarityMul, 0.0, 1.0);
	
	gl_FragColor = vec4( rgb, 1.0);
    
    /*
     // old implementation,.. clarity is calculated before blur
     mediump vec3 rgb = texture2D( blurMaps0, texCoord ).rgb;
     mediump vec3 ldrgb = texture2D( clarityMap, texCoord ).rgb;
     rgb = clamp( rgb + (rgb-ldrgb)*clarityMul, 0.0, 1.0);
     
     highp float amount = 1.0 - texture2D( blurAmount, texCoord ).g;
     rgb = mix( rgb, sampleBlurMap( amount * 3.99 ), clamp( (amount - 0.2)*6.0, 0.0, 1.0 ));
     
     
     gl_FragColor = vec4( lut3d(rgb).rgb, 1.0);
     */
}