uniform sampler2D blurMaps0;
uniform sampler2D blurMaps1;
uniform sampler2D blurMaps2;
uniform sampler2D blurMaps3;
uniform sampler2D blurMaps4;
uniform sampler2D blurAmount;						// map to define the amount of blurring
uniform sampler2D lutTex;

uniform mediump mat4 curvePoints;
uniform mediump mat3 inputMuls;

varying highp vec2 texCoord;


#+libblurmap.glsl

mediump float spline( mediump int i, mediump float pos ) 
{
	return ((curvePoints[i][3]*pos + curvePoints[i][2])*pos +curvePoints[i][1])*pos + curvePoints[i][0];
}

void main()
{
    highp float amount = 1.0 - texture2D( blurAmount, texCoord ).g;
    mediump vec3 rgb = clamp( sampleBlurMap( amount * 3.99 ), 0.0, 1.0);
    mediump vec3 ldrgb = texture2D( clarityMap, texCoord ).rgb;
    rgb = clamp( (rgb + (rgb-ldrgb)*clarityMul) * inputMuls, 0.0, 1.0);
	gl_FragColor = clamp( vec4( spline(0,rgb.r), spline(1,rgb.g), spline(2,rgb.b), 1.0 ), 0.0, 1.0 );
}


