uniform sampler2D blurMaps0;
uniform sampler2D blurMaps1;
uniform sampler2D blurMaps2;
uniform sampler2D blurMaps3;
uniform sampler2D blurMaps4;
uniform sampler2D blurAmount;						// map to define the amount of blurring

uniform mediump float fadeout;
uniform highp float desaturate;

uniform mediump vec3 colorAdd;
uniform mediump vec3 colorMul;


varying highp vec2 texCoord;


#+libblurmap.glsl


void main()
{
	highp float fadervalue = 1.0 - texture2D( blurAmount, texCoord ).g;
    mediump vec3 bmapcol = sampleBlurMap( fadervalue * 3.99 ) + colorAdd;
    
    bmapcol = clamp(bmapcol*colorMul,0.0,1.0);
    
	//fadervalue = 1.0 - 4.0 / (4.0 + fadervalue*8.0);
    bmapcol = bmapcol * (1.0 - fadervalue*fadeout);
	mediump float gray = dot( bmapcol, vec3(0.299,0.587,0.114) );
	gl_FragColor = vec4( mix( bmapcol, vec3(gray,gray,gray), fadervalue*desaturate ), 1.0);
}


