uniform sampler2D blurMaps0;
uniform sampler2D blurMaps1;
uniform sampler2D blurMaps2;
uniform sampler2D blurMaps3;
uniform sampler2D blurMaps4;
uniform sampler2D blurAmount;						// map to define the amount of blurring
uniform sampler2D lutTex;

uniform mediump float fadeout;
uniform highp float desaturate;

varying highp vec2 texCoord;

#+libblurmap.glsl
#+shaderlib1.glsl


void main()
{
	highp float fadervalue = 1.0 - texture2D( blurAmount, texCoord ).g;


    mediump vec3 bmapcol = sampleBlurMap( fadervalue * 3.99 );


    bmapcol = lut3d( bmapcol ).rgb * (1.0 - fadervalue*fadeout);
	mediump float gray = dot( bmapcol, vec3(0.299,0.587,0.114) );
	
	gl_FragColor = vec4( mix( bmapcol, vec3(gray,gray,gray), clamp(fadervalue*desaturate, 0.0, 1.0) ), 1.0);

}


