uniform sampler2D SamplerRGB;
uniform sampler2D lowDetailSamplerRGB;
uniform mediump mat4 curvePoints;
uniform mediump mat3 inputMuls;
uniform mediump float clarityMul;
varying highp vec2 texCoord;


mediump float spline( mediump int i, mediump float pos ) 
{
	return ((curvePoints[i][3]*pos + curvePoints[i][2])*pos +curvePoints[i][1])*pos + curvePoints[i][0];
}

void main()
{
    mediump vec3 rgb = texture2D( SamplerRGB, texCoord ).rgb;
    mediump vec3 ldrgb = texture2D( lowDetailSamplerRGB, texCoord ).rgb;
    rgb = clamp( (rgb + (rgb-ldrgb)*clarityMul)*inputMuls, 0.0, 1.0);
	gl_FragColor = clamp( vec4( spline(0,rgb.r), spline(1,rgb.g), spline(2,rgb.b), 1.0 ), 0.0, 1.0 );
}




