uniform sampler2D texInput;
uniform sampler2D texVignette;
uniform sampler2D texDistort;
uniform sampler2D texNoise;
uniform mediump float vignettePower;
uniform mediump float vignetteLoops;
uniform mediump float disPos;
uniform mediump float mainYPos;
uniform mediump vec4 noiseAttr;

varying highp vec2 texCoord;

void main()
{
	mediump vec3 vig = texture2D( texVignette, texCoord*vignetteLoops).rgb;
	mediump vec3 dis = texture2D( texDistort, vec2( texCoord.x, disPos ) ).rgb;	
	mediump float edgeMul = abs( fract(mainYPos+texCoord.x)-0.5)*2.0;			// how near we are at the top or bottom (left / right)
	mediump float noiseMul = (edgeMul * 0.25 + 0.15) * (20.0- abs(mainYPos-0.5)*38.0);		// increase error when screen is moving up/down
	mediump vec3 rgb =  texture2D(texInput, fract(texCoord + vec2(mainYPos, ((dis.r*dis.r) - (dis.g*dis.g))*noiseMul ) )).rgb;
	mediump vec3 noise =  texture2D(texNoise, noiseAttr.xy + vec2( texCoord.y*0.5, texCoord.x*2.0 ) ).rgb;
	mediump float noiseAmount = (dis.b*dis.b)*noiseMul;	// edgemul is between 0 and 1
	rgb = mix( rgb, noise, clamp( noiseAmount, 0.1, 1.0) ); 
	gl_FragColor = vec4( clamp( rgb*vig*vignettePower, 0.0, 1.0), 1.0 );
}