

uniform sampler2D SamplerRGB;
uniform mediump int dither[64];         // arriving from the caller
uniform highp float Scale;
uniform highp vec2 backbufferSize;
varying highp vec2 texCoord;





highp float find_closest(highp int x, highp int y, highp float c0)
{
    //if (c0 < (float( dither[y*8+x]+1 ) / 64.0)) return 0.0; else return 1.0;
    return clamp( 0.5 + (c0*64.0 - (float( dither[y*8+x]+1 ))),0.0, 1.0 );
}



void main(void)
{
    highp vec2 s = vec2( Scale, Scale  / backbufferSize.y * backbufferSize.x );
    highp vec2 pixelPos = floor(texCoord * s);

    highp vec3 rgb = texture2D(SamplerRGB, pixelPos/s).rgb;
    
    
    highp int x = int(mod(pixelPos.x, 8.0));
    highp int y = int(mod(pixelPos.y, 8.0));
    
    gl_FragColor = vec4(find_closest(x, y, rgb.r),find_closest(x, y, rgb.g), find_closest(x, y, rgb.b), 1.0);

    //gl_FragColor = vec4( 1.0, 0.0, 1.0, 1.0 );

}