/**
 *
 * Lens effect from photorim
 *
 */

uniform sampler2D SamplerRGB;
varying highp vec2 texCoord;

uniform mediump float lens_base;
uniform mediump float lens_pow;


void main()
{
    mediump vec2 delta = (texCoord - vec2(0.5, 0.5))*2.0;
    mediump float mul = lens_base + pow(dot( delta, delta )*0.5, lens_pow)*(1.0-lens_base);
    gl_FragColor = vec4( texture2D(SamplerRGB, vec2(0.5, 0.5) + delta * mul * 0.5).rgb, 1.0);
    
    
}