
    // scan 5x5 static kernel
varying highp vec2 texCoord;
uniform mediump sampler2D text;                 // original image .. for the matching
uniform highp vec2 matchOffset;
uniform highp float gaussianSigma;
uniform mediump vec3 kernelOffsets[25];
uniform highp float hvalue;



void main() {
    highp vec3 dif;
    highp float power;
    mediump int i=0;

    highp vec3 middleColor = texture2D( text, texCoord ).rgb;
    highp vec3 tcolor;
    highp vec3 finalColor = vec3(0);
    highp float finalPower = 0.0;

    highp vec2 otherPos = texCoord + matchOffset;
    while (i<25) {
        tcolor = texture2D(text, otherPos + kernelOffsets[i].xy).rgb;
        dif = (middleColor - tcolor);
        power = exp(-dot(dif,dif)/hvalue);
        finalPower += power;
        finalColor += tcolor * power;
        i++;
    }


    /*
        // GRADIENT TEST!
    highp vec2 otherPos = texCoord + matchOffset;
    highp vec2 otherPos2 = texCoord - matchOffset;
    while (i<25) {
        tcolor = (texture2D(text, otherPos + kernelOffsets[i].xy).rgb + texture2D(text, otherPos2 - kernelOffsets[i].xy).rgb)*0.5;
        dif = (middleColor - tcolor);
        power = clamp( 1.0 - dot(dif, dif)*128.0, 0.0, 1.0) * kernelOffsets[i].z;
        finalPower += power;
        finalColor += tcolor * power;

        i++;
    }
     */

        // finalpower cannot be over 1 since 0.04 = 1/25 and 25 is the kernel size
    gl_FragColor = vec4( finalColor*0.04, finalPower*0.04 );
}



