

varying highp vec2 texCoord;
uniform mediump sampler2D text;
uniform mediump sampler2D offsetTex;
uniform highp vec2 backbufferSize;

    // kernel size 5x5 is static
uniform highp vec3 kernel[25];          // xy is the offset, z is multiplier for this


mediump vec3 middleData[25];            // first scan the middle data here.
highp float myError;
highp vec2 myOffset;
highp vec2 sampleR;



highp float blockError( highp vec2 pos ) {
    return 1.0;
    highp float rval = 0.0;
    mediump vec3 dif;
    for (int iii=0; iii<25; iii++) {
        dif = texture2D(text, pos + kernel[iii].xy).rgb - middleData[i];
        rval += dot(dif, dif) * kernel[iii].z;            // kernel.z has the mask multiplier
    }
    return rval;
}


    // we need to think about these? howto do this the best
highp vec2 decodeOffsetVec( highp vec4 packedPos ) {
    return vec2( (packedPos.x*255.0 + packedPos.y), (packedPos.z*255.0 + packedPos.w) ) / 256.0;
}


highp vec4 codeOffsetVec( highp vec2 upos ) {
    highp vec2 temp = upos * 256.0;
    return vec4( temp.x / 256.0, temp.x - floor(temp.x), temp.y / 256.0, temp.y - floor(temp.y) );
}


void checkOffsetPosition( highp vec2 checkOffset ) {
    highp float checkError = blockError( checkOffset );

    // NOTE, TODO: don't allow actual match ... checkOffset == screenPos
    
    if (checkError<myError) {               // it was better, .. adopt it.
        myError = checkError;
        //myOffset = checkOffset;
    }
}


void main() {
        // initialize units
    sampleR = vec2(1.0/backbufferSize.x, 1.0/backbufferSize.y);
    highp vec2 screenPos = texCoord; //vec2( gl_FragCoord.x / backbufferSize.y, gl_FragCoord.y / backbufferSize.x);


        // Scan the middle-data for comparasion
    for (int i=0; i<25; i++) {
        middleData[i] = texture2D(text, screenPos + kernel[i].xy*sampleR).rgb;
    }

        // check my current offset and error
    myOffset = decodeOffsetVec( texture2D( offsetTex, screenPos ) );
    //myError = blockError( myOffset );

/*
        // check if one of the neighbours have better offset and take it if so
    checkOffsetPosition( decodeOffsetVec( texture2D( off	setTex, vec2( screenPos.x + sampleR.x, screenPos.y ) ) ) );
    checkOffsetPosition( decodeOffsetVec( texture2D( offsetTex, vec2( screenPos.x - sampleR.x, screenPos.y ) ) ) );
    checkOffsetPosition( decodeOffsetVec( texture2D( offsetTex, vec2( screenPos.x, screenPos.y + sampleR.y ) ) ) );
    checkOffsetPosition( decodeOffsetVec( texture2D( offsetTex, vec2( screenPos.x, screenPos.y - sampleR.y ) ) ) );
 */



    // try to tweak our own position
    //checkOffsetPosition( vec2( myOffset.x + sampleR.x, myOffset.y ) );
    //checkOffsetPosition( vec2( myOffset.x - sampleR.x, myOffset.y ) );
    //checkOffsetPosition( vec2( myOffset.x, myOffset.y + sampleR.x ) );
    //checkOffsetPosition( vec2( myOffset.x, myOffset.y + sampleR.y ) );



    gl_FragColor = codeOffsetVec( myOffset );
    
    gl_FragColor = texture2D( offsetTex, screenPos );

    //gl_FragColor = vec4( 1, 0, 1, 1);

    //gl_FragColor = vec4( screenPos, 0.0, 1.0);
}



