
uniform sampler2D SamplerRGB;
uniform highp vec2 backbufferSize;
uniform highp float power;
uniform highp float pixelSize;
varying highp vec2 texCoord;




  

void main()
{
	mediump vec2 samplingUnit = vec2( pixelSize/backbufferSize.x, pixelSize/backbufferSize.y );
    highp vec3 middle = texture2D(SamplerRGB, texCoord).rgb;

	highp vec3 total = texture2D(SamplerRGB, texCoord + vec2(-samplingUnit.x, -samplingUnit.y)).rgb * -1.0 +
                       texture2D(SamplerRGB, texCoord + vec2(0.0, -samplingUnit.y)).rgb * -1.0 +
                       texture2D(SamplerRGB, texCoord + vec2(samplingUnit.x, -samplingUnit.y)).rgb * -1.0 +
                       texture2D(SamplerRGB, texCoord + vec2(-samplingUnit.x, 0.0)).rgb * -1.0 +
                       texture2D(SamplerRGB, texCoord + vec2(samplingUnit.x, 0.0)).rgb * -1.0 +
                       texture2D(SamplerRGB, texCoord + vec2(-samplingUnit.x, -samplingUnit.y)).rgb * -1.0 +
                       texture2D(SamplerRGB, texCoord + vec2(0.0, -samplingUnit.y)).rgb * -1.0 +
                       texture2D(SamplerRGB, texCoord + vec2(samplingUnit.x, -samplingUnit.y)).rgb * -1.0 +
                       middle * 9.0;
    
    
    gl_FragColor = vec4( mix(middle, total, power), 1.0);
}