uniform sampler2D texInput;
uniform sampler2D texVignette;
uniform sampler2D texNoise;
uniform mediump float vignettePower;
uniform mediump vec4 noiseAttr;

varying highp vec2 texCoord;

    
void main()
{
	mediump vec3 vig = texture2D( texVignette, texCoord ).rgb;
	mediump vec3 rgb =  texture2D(texInput, texCoord ).rgb;
	mediump vec3 noise =  texture2D(texNoise, (texCoord+noiseAttr.xy)*noiseAttr.zw*2.0 ).rgb;
	gl_FragColor = vec4( clamp( rgb*vig * noise * vignettePower, 0.0, 1.0), 1.0 );
}