uniform sampler2D texInput;
uniform sampler2D texVignette;
uniform sampler2D texNoise;
uniform sampler2D texLightLeak;
uniform mediump float vignettePower;
uniform mediump vec4 noiseAttr;
uniform mediump vec4 lightLeakAttr;

varying highp vec2 texCoord;

    
void main()
{
	mediump vec3 vig = texture2D( texVignette, texCoord ).rgb;
	mediump vec3 rgb =  texture2D(texInput, texCoord ).rgb;
	mediump vec3 noise =  texture2D(texNoise, (texCoord+noiseAttr.xy)*noiseAttr.zw*2.0 ).rgb;
    mediump vec3 lightLeak = texture2D(texLightLeak, 
    	(texCoord-vec2(0.5, 0.5))*lightLeakAttr.zw+lightLeakAttr.xy*0.5+vec2(0.5, 0.5)).rgb;
    	
    	// lightleak over everything
	//gl_FragColor = vec4( clamp( rgb*vig * noise * vignettePower + lightLeak, 0.0, 1.0), 1.0 );
	
		// lightleak under 
	gl_FragColor = vec4( clamp( (rgb+lightLeak)*vig * noise * vignettePower, 0.0, 1.0), 1.0 );
}